﻿/**
 *
 * Copyright (c) 2002-2004 Bluetetra Software.  All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL BLUETETRA SOFTWARE BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *  
 * http://www.bluetetra.com
 *
 */

var wc_target = "content";
var wc_fileName = "wsdlComponentIndex.html";
var wc_nsFilterFileName = "nsFilter.html";


function WCN (href, name, appendNSFlag, children) {
	this.href = href;
	this.name = name;
	this.appendNSFlag = appendNSFlag;

	this.children = children;
	this.hasChild = (children != null) && (children.length>0);	
	
	this.namespace = null;
}

function WC (serviceList, messageList, portTypeList, bindingList)
{
	this.services = serviceList;
	this.messages = messageList;
	this.portTypes = portTypeList;
	this.bindings = bindingList;
}

function wc_showAllComponents() {
	parent._wsdlNsFilter = null;
	parent.index.location.href= "wsdl/" + wc_fileName;
}

function wc_filterComponents () {
	parent._href = "wsdl/" + wc_fileName;
	window.open(wc_nsFilterFileName, "_blank", 
		"height=200,width=400,location=no,menubar=no,scrollbars=yes,status=yes,resizable=yes,toolbar=no");

}

function wc_groupByNS (flag) {
	parent._groupByNSFlag = flag;
	parent.index.location.href= wc_fileName;	
}

function wc_setFilterToAll() {
	var nsList = new Array();
	var i = 0;

	for (var ns in wcDB) {
		nsList[i] = ns; 		
		i++;
	}

	parent._wsdlNsFilter = nsList;
}


function wc_showComponentsNoNS (nsList, componentList) {

	var components = new Array ();
	var n = 0;

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			components[n] = list[j];
			components[n].namespace = namespace;
			n++;	
		}	
	}
	
	components = components.sort(function (n1,n2) {return n1.name.toLowerCase().localeCompare (n2.name.toLowerCase());});

	wc_outputList (null, components);	
}


function wc_showComponentsNS (nsList, componentList) {

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			list[j].namespace = namespace;
		}	

		wc_outputList (namespace, list);	
	}
}


function wc_showComponents (nsList, componentList) {
	if (parent._groupByNSFlag) {
		wc_showComponentsNS (nsList, componentList)
	} else {
		wc_showComponentsNoNS (nsList, componentList)
	}
}

function wc_showServices() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var services = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		services [i] = wcDB [nsList[i]].services;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, services);
}

function wc_showMessages() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var messages = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		messages [i] = wcDB [nsList[i]].messages;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, messages);
}

function wc_showPortTypes() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var portTypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		portTypes [i] = wcDB [nsList[i]].portTypes;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, portTypes);
}


function wc_showBindings() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var bindings = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		bindings [i] = wcDB [nsList[i]].bindings;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, bindings);
}

function wc_getNodeText(node) {
	if (node.appendNSFlag) {
		return node.name + "("+encodeURI(node.namespace)+")";
	} else {
		return node.name;
	} 
}

function wc_outputLeaf (node) {
	var str = '<span class="leaf">'+
			  '<nobr><img src="img/leaf.gif" hspace="2" align="middle">'+
			  '<a class="chref" href="'+node.href+
			  '" title="'+ wc_getNodeText(node)+
			  '" target="'+ wc_target+'">'+ wc_getNodeText(node)+'</a></nobr>'+
			  '</span><br />'
	
	document.write (str);
}

function wc_outputNonLeaf (node) {
	//initially, the childnodes are hidden

	var str = '<div><div class="nonleaf">'+
			'<nobr><img style="cursor: pointer" src="img/plus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
			'<a class="chref" href="'+node.href+
			'" title="'+ wc_getNodeText(node)+
			'" target="'+ wc_target +'">'+ wc_getNodeText(node)+'</a></nobr></div>'+
			'<div style="display:none;margin-left: 0.8em">';

	document.write (str);

	var childs = node.children;
	for (var i=0; i<childs.length; i++) {
		wc_outputTree (childs[i]);
	}					

	document.write ('</div></div>');
}

function wc_outputTree (node) {
	if (node.hasChild == false) {
		wc_outputLeaf (node);
	} else {
		wc_outputNonLeaf (node);
	}
}

function wc_outputList (ns, list) {	
	
	if (list == null || list.length<=0) {
		return;
	}

	if (parent._groupByNSFlag) {
		var fpath = wcNSMap[ns];

		var str = '<div class="nsBox"><div class="itemNS">'+
				'<nobr><img style="cursor: pointer" src="img/minus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
				'<a class="chref" href="'+fpath+
				'" title="'+encodeURI(ns)+
				'" target="'+ wc_target +'">'+encodeURI(ns)+'</a></nobr></div>'+
				'<div style="margin-left: 0.5em">';

		document.write (str);
	}

	for (var i=0; i<list.length; i++) {
		wc_outputTree (list[i]);
	}
	
	if (parent._groupByNSFlag) {
		document.write ('</div></div>');
	}
}

var wcDB = new Array();
var wcNSMap = new Array();

wcDB ["http://www.ibm.com/wsdl/twss/nm/adm/v1_0/interface"] =  new WC (
					new Array(),
					new Array(new WCN("2/message/NotificationAdministration_countAllRequest.html","NotificationAdministration_countAllRequest",false,null),new WCN("2/message/NotificationAdministration_countByNotificationPortTypeEndPointRequest.html","NotificationAdministration_countByNotificationPortTypeEndPointRequest",false,null),new WCN("2/message/NotificationAdministration_countByStartEndPeriodCountRequest.html","NotificationAdministration_countByStartEndPeriodCountRequest",false,null),new WCN("2/message/NotificationAdministration_countByTargetCriterionRequest.html","NotificationAdministration_countByTargetCriterionRequest",false,null),new WCN("2/message/NotificationAdministration_countExactlyGlobalTransactionIDRequest.html","NotificationAdministration_countExactlyGlobalTransactionIDRequest",false,null),new WCN("2/message/NotificationAdministration_countExactlyRequesterServiceCorrelatorRequest.html","NotificationAdministration_countExactlyRequesterServiceCorrelatorRequest",false,null),new WCN("2/message/NotificationAdministration_countResponse.html","NotificationAdministration_countResponse",false,null),new WCN("2/message/NotificationAdministration_findAllRequest.html","NotificationAdministration_findAllRequest",false,null),new WCN("2/message/NotificationAdministration_findByNotificationPortTypeEndPointRequest.html","NotificationAdministration_findByNotificationPortTypeEndPointRequest",false,null),new WCN("2/message/NotificationAdministration_findByStartEndPeriodCountRequest.html","NotificationAdministration_findByStartEndPeriodCountRequest",false,null),new WCN("2/message/NotificationAdministration_findByTargetCriterionRequest.html","NotificationAdministration_findByTargetCriterionRequest",false,null),new WCN("2/message/NotificationAdministration_findExactlyGlobalTransactionIDRequest.html","NotificationAdministration_findExactlyGlobalTransactionIDRequest",false,null),new WCN("2/message/NotificationAdministration_findExactlyRequesterServiceCorrelatorRequest.html","NotificationAdministration_findExactlyRequesterServiceCorrelatorRequest",false,null),new WCN("2/message/NotificationAdministration_findNextNRecordsRequest.html","NotificationAdministration_findNextNRecordsRequest",false,null),new WCN("2/message/NotificationAdministration_findNextNRecordsResponse.html","NotificationAdministration_findNextNRecordsResponse",false,null),new WCN("2/message/NotificationAdministration_findResponse.html","NotificationAdministration_findResponse",false,null),new WCN("2/message/NotificationAdministration_resetStatisticsByNotificationPortTypeEndPointRequest.html","NotificationAdministration_resetStatisticsByNotificationPortTypeEndPointRequest",false,null),new WCN("2/message/NotificationAdministration_resetStatisticsByStartEndPeriodCountRequest.html","NotificationAdministration_resetStatisticsByStartEndPeriodCountRequest",false,null),new WCN("2/message/NotificationAdministration_resetStatisticsByTargetCriterionRequest.html","NotificationAdministration_resetStatisticsByTargetCriterionRequest",false,null),new WCN("2/message/NotificationAdministration_resetStatisticsForAllRequest.html","NotificationAdministration_resetStatisticsForAllRequest",false,null),new WCN("2/message/NotificationAdministration_resetStatisticsForExactlyGlobalTransactionIDRequest.html","NotificationAdministration_resetStatisticsForExactlyGlobalTransactionIDRequest",false,null),new WCN("2/message/NotificationAdministration_resetStatisticsForExactlyRequesterServiceCorrelatorRequest.html","NotificationAdministration_resetStatisticsForExactlyRequesterServiceCorrelatorRequest",false,null),new WCN("2/message/NotificationAdministration_resetStatisticsResponse.html","NotificationAdministration_resetStatisticsResponse",false,null),new WCN("2/message/NotificationAdministration_terminateAllRequest.html","NotificationAdministration_terminateAllRequest",false,null),new WCN("2/message/NotificationAdministration_terminateByNotificationPortTypeEndPointRequest.html","NotificationAdministration_terminateByNotificationPortTypeEndPointRequest",false,null),new WCN("2/message/NotificationAdministration_terminateByStartEndPeriodCountRequest.html","NotificationAdministration_terminateByStartEndPeriodCountRequest",false,null),new WCN("2/message/NotificationAdministration_terminateByTargetCriterionRequest.html","NotificationAdministration_terminateByTargetCriterionRequest",false,null),new WCN("2/message/NotificationAdministration_terminateExactlyGlobalTransactionIDRequest.html","NotificationAdministration_terminateExactlyGlobalTransactionIDRequest",false,null),new WCN("2/message/NotificationAdministration_terminateExactlyRequesterServiceCorrelatorRequest.html","NotificationAdministration_terminateExactlyRequesterServiceCorrelatorRequest",false,null),new WCN("2/message/NotificationAdministration_terminateResponse.html","NotificationAdministration_terminateResponse",false,null)),
					new Array(new WCN("2/porttype/NotificationAdministration.html","NotificationAdministration",false,new Array(new WCN("2/operation/countAll_0.html","countAll",false,null),new WCN("2/operation/countByNotificationPortTypeEndPoint_12.html","countByNotificationPortTypeEndPoint",false,null),new WCN("2/operation/countByStartEndPeriodCount_20.html","countByStartEndPeriodCount",false,null),new WCN("2/operation/countByTargetCriterion_16.html","countByTargetCriterion",false,null),new WCN("2/operation/countExactlyGlobalTransactionID_8.html","countExactlyGlobalTransactionID",false,null),new WCN("2/operation/countExactlyRequesterServiceCorrelator_4.html","countExactlyRequesterServiceCorrelator",false,null),new WCN("2/operation/findAll_1.html","findAll",false,null),new WCN("2/operation/findByNotificationPortTypeEndPoint_13.html","findByNotificationPortTypeEndPoint",false,null),new WCN("2/operation/findByStartEndPeriodCount_21.html","findByStartEndPeriodCount",false,null),new WCN("2/operation/findByTargetCriterion_17.html","findByTargetCriterion",false,null),new WCN("2/operation/findExactlyGlobalTransactionID_9.html","findExactlyGlobalTransactionID",false,null),new WCN("2/operation/findExactlyRequesterServiceCorrelator_5.html","findExactlyRequesterServiceCorrelator",false,null),new WCN("2/operation/findNextNRecords_24.html","findNextNRecords",false,null),new WCN("2/operation/resetStatisticsByNotificationPortTypeEndPoint_14.html","resetStatisticsByNotificationPortTypeEndPoint",false,null),new WCN("2/operation/resetStatisticsByStartEndPeriodCount_22.html","resetStatisticsByStartEndPeriodCount",false,null),new WCN("2/operation/resetStatisticsByTargetCriterion_18.html","resetStatisticsByTargetCriterion",false,null),new WCN("2/operation/resetStatisticsForAll_2.html","resetStatisticsForAll",false,null),new WCN("2/operation/resetStatisticsForExactlyGlobalTransactionID_10.html","resetStatisticsForExactlyGlobalTransactionID",false,null),new WCN("2/operation/resetStatisticsForExactlyRequesterServiceCorrelator_6.html","resetStatisticsForExactlyRequesterServiceCorrelator",false,null),new WCN("2/operation/terminateAll_3.html","terminateAll",false,null),new WCN("2/operation/terminateByNotificationPortTypeEndPoint_15.html","terminateByNotificationPortTypeEndPoint",false,null),new WCN("2/operation/terminateByStartEndPeriodCount_23.html","terminateByStartEndPeriodCount",false,null),new WCN("2/operation/terminateByTargetCriterion_19.html","terminateByTargetCriterion",false,null),new WCN("2/operation/terminateExactlyGlobalTransactionID_11.html","terminateExactlyGlobalTransactionID",false,null),new WCN("2/operation/terminateExactlyRequesterServiceCorrelator_7.html","terminateExactlyRequesterServiceCorrelator",false,null)))),
					new Array()
					);

wcNSMap ["http://www.ibm.com/wsdl/twss/nm/adm/v1_0/interface"] = "2/index.html";
wcDB ["http://www.ibm.com/wsdl/twss/nm/adm/v1_0/service"] =  new WC (
					new Array(new WCN("5/service/NotificationAdministrationService.html","NotificationAdministrationService",false,null)),
					new Array(),
					new Array(),
					new Array(new WCN("5/binding/NotificationAdministrationBinding.html","NotificationAdministrationBinding",false,new Array(new WCN("2/operation/countAll_0.html","countAll",false,null),new WCN("2/operation/countByNotificationPortTypeEndPoint_12.html","countByNotificationPortTypeEndPoint",false,null),new WCN("2/operation/countByStartEndPeriodCount_20.html","countByStartEndPeriodCount",false,null),new WCN("2/operation/countByTargetCriterion_16.html","countByTargetCriterion",false,null),new WCN("2/operation/countExactlyGlobalTransactionID_8.html","countExactlyGlobalTransactionID",false,null),new WCN("2/operation/countExactlyRequesterServiceCorrelator_4.html","countExactlyRequesterServiceCorrelator",false,null),new WCN("2/operation/findAll_1.html","findAll",false,null),new WCN("2/operation/findByNotificationPortTypeEndPoint_13.html","findByNotificationPortTypeEndPoint",false,null),new WCN("2/operation/findByStartEndPeriodCount_21.html","findByStartEndPeriodCount",false,null),new WCN("2/operation/findByTargetCriterion_17.html","findByTargetCriterion",false,null),new WCN("2/operation/findExactlyGlobalTransactionID_9.html","findExactlyGlobalTransactionID",false,null),new WCN("2/operation/findExactlyRequesterServiceCorrelator_5.html","findExactlyRequesterServiceCorrelator",false,null),new WCN("2/operation/findNextNRecords_24.html","findNextNRecords",false,null),new WCN("2/operation/resetStatisticsByNotificationPortTypeEndPoint_14.html","resetStatisticsByNotificationPortTypeEndPoint",false,null),new WCN("2/operation/resetStatisticsByStartEndPeriodCount_22.html","resetStatisticsByStartEndPeriodCount",false,null),new WCN("2/operation/resetStatisticsByTargetCriterion_18.html","resetStatisticsByTargetCriterion",false,null),new WCN("2/operation/resetStatisticsForAll_2.html","resetStatisticsForAll",false,null),new WCN("2/operation/resetStatisticsForExactlyGlobalTransactionID_10.html","resetStatisticsForExactlyGlobalTransactionID",false,null),new WCN("2/operation/resetStatisticsForExactlyRequesterServiceCorrelator_6.html","resetStatisticsForExactlyRequesterServiceCorrelator",false,null),new WCN("2/operation/terminateAll_3.html","terminateAll",false,null),new WCN("2/operation/terminateByNotificationPortTypeEndPoint_15.html","terminateByNotificationPortTypeEndPoint",false,null),new WCN("2/operation/terminateByStartEndPeriodCount_23.html","terminateByStartEndPeriodCount",false,null),new WCN("2/operation/terminateByTargetCriterion_19.html","terminateByTargetCriterion",false,null),new WCN("2/operation/terminateExactlyGlobalTransactionID_11.html","terminateExactlyGlobalTransactionID",false,null),new WCN("2/operation/terminateExactlyRequesterServiceCorrelator_7.html","terminateExactlyRequesterServiceCorrelator",false,null))))
					);

wcNSMap ["http://www.ibm.com/wsdl/twss/nm/adm/v1_0/service"] = "5/index.html";
wcDB ["http://www.ibm.com/wsdl/twss/nm/v1_0/faults"] =  new WC (
					new Array(),
					new Array(new WCN("4/message/NotificationDuplicateFault.html","NotificationDuplicateFault",false,null),new WCN("4/message/NotificationNotFoundFault.html","NotificationNotFoundFault",false,null),new WCN("4/message/NotificationRequestInvalidFault.html","NotificationRequestInvalidFault",false,null),new WCN("4/message/NotificationServiceFault.html","NotificationServiceFault",false,null),new WCN("4/message/NotificationTerminationNotSupportedFault.html","NotificationTerminationNotSupportedFault",false,null)),
					new Array(),
					new Array()
					);

wcNSMap ["http://www.ibm.com/wsdl/twss/nm/v1_0/faults"] = "4/index.html";
