﻿/**
 *
 * Copyright (c) 2002-2004 Bluetetra Software.  All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL BLUETETRA SOFTWARE BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *  
 * http://www.bluetetra.com
 *
 */

var target = "content";
var xsd_ciFileName = "componentIndex.html";
var xsd_nsFilterFileName = "nsFilter.html";

function CN (href, name, appendNSFlag, children) {
	this.href = href;
	this.name = name;
	this.appendNSFlag = appendNSFlag;

	this.children = children;
	this.hasChild = (children != null) && (children.length>0);	
	
	this.namespace = null;
}

function C (attributeList, attributeGroupList,
						simpleTypeList, complexTypeList,
						modelGroupList, elementList, 
						notationList) 
{
	this.attributes = attributeList;
	this.attributegroups = attributeGroupList;
	this.simpletypes = simpleTypeList;
	this.complextypes = complexTypeList;
	this.modelgroups = modelGroupList;
	this.elements = elementList;
	this.notations = notationList;
}

function component_showAllComponents() {
	parent._xsdNsFilter = null;
	parent.index.location.href= "xsd/" + xsd_ciFileName;
}

function component_filterComponents () {
	parent._href = "xsd/" + xsd_ciFileName;
	window.open(xsd_nsFilterFileName, "_blank", 
		"height=200,width=400,location=no,menubar=no,scrollbars=yes,status=yes,resizable=yes,toolbar=no");

}

function component_groupByNS (flag) {
	parent._groupByNSFlag = flag;
	parent.index.location.href=xsd_ciFileName;	
}

function component_setFilterToAll() {
	var nsList = new Array();
	var i = 0;

	for (var ns in componentDB) {
		if (parent._xsdNsFilter == null) {
			if (ns == "http://schemas.xmlsoap.org/soap/encoding/") {
				//NOOP
			} else {
				nsList[i] = ns;
				i++;
			}
		} else {
			nsList[i] = ns; 
			i++;		
		}
	}

	parent._xsdNsFilter = nsList;
}

function component_showComponentsNoNS (nsList, componentList) {

	var components = new Array ();
	var n = 0;

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			components[n] = list[j];
			components[n].namespace = namespace;
			n++;	
		}	
	}
	
	components = components.sort(function (n1,n2) {return n1.name.toLowerCase().localeCompare (n2.name.toLowerCase());});

	component_outputList (null, components);	
}


function component_showComponentsNS (nsList, componentList) {

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			list[j].namespace = namespace;
		}	

		component_outputList (namespace, list);	
	}
}


function component_showComponents (nsList, componentList) {
	if (parent._groupByNSFlag) {
		component_showComponentsNS (nsList, componentList)
	} else {
		component_showComponentsNoNS (nsList, componentList)
	}
}

function component_showAttributes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var attributes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		attributes [i] = componentDB [nsList[i]].attributes;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, attributes);
}

function component_showAttributeGroups() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var attributegroups = new Array();
	var nss = new Array();		

	for (var i=0; i<nsList.length; i++) {
		attributegroups [i] = componentDB [nsList[i]].attributegroups;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, attributegroups);
}

function component_showSimpleTypes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var simpletypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		simpletypes [i] = componentDB [nsList[i]].simpletypes;	
		nss [i] = nsList[i];
	}		

	component_showComponents (nss, simpletypes);
}

function component_showComplexTypes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var complextypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		complextypes [i] = componentDB [nsList[i]].complextypes;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, complextypes);
}

function component_showElements() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var elements = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		elements [i] = componentDB [nsList[i]].elements;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, elements);
}

function component_showModelGroups() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var modelgroups = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		modelgroups [i] = componentDB [nsList[i]].modelgroups;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, modelgroups);
}

function component_showNotations() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var notations = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		notations [i] = componentDB [nsList[i]].notations;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, notations);

}


function component_getNodeText(node) {
	if (node.appendNSFlag) {
		return node.name + "("+encodeURI(node.namespace)+")";
	} else {
		return node.name;
	} 
}

function component_outputLeaf (node) {
	var str = '<span class="leaf">'+
			  '<nobr><img src="img/leaf.gif" hspace="2" align="middle">'+
			  '<a class="chref" href="'+node.href+
			  '" title="'+component_getNodeText(node)+
			  '" target="'+target+'">'+component_getNodeText(node)+'</a></nobr>'+
			  '</span><br />'
	
	document.write (str);
}

function component_outputNonLeaf (node) {
	//initially, the childnodes are hidden

	var str = '<div><div class="nonleaf">'+
			'<nobr><img style="cursor: pointer" src="img/plus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
			'<a class="chref" href="'+node.href+
			'" title="'+component_getNodeText(node)+
			'" target="'+target+'">'+component_getNodeText(node)+'</a></nobr></div>'+
			'<div style="display:none;margin-left: 0.8em">';

	document.write (str);

	var childs = node.children;
	for (var i=0; i<childs.length; i++) {
		component_outputTree (childs[i]);
	}					

	document.write ('</div></div>');
}

function component_outputTree (node) {
	if (node.hasChild == false) {
		component_outputLeaf (node);
	} else {
		component_outputNonLeaf (node);
	}
}

function component_outputList (ns, list) {	
	
	if (list == null || list.length<=0) {
		return;
	}

	if (parent._groupByNSFlag) {
		var fpath = componentNSMap[ns];

		var str = '<div class="nsBox"><div class="itemNS">'+
				'<nobr><img style="cursor: pointer" src="img/minus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
				'<a class="chref" href="'+fpath+
				'" title="'+encodeURI(ns)+
				'" target="'+target+'">'+encodeURI(ns)+'</a></nobr></div>'+
				'<div style="margin-left: 0.5em">';

		document.write (str);
	}

	for (var i=0; i<list.length; i++) {
		component_outputTree (list[i]);
	}
	
	if (parent._groupByNSFlag) {
		document.write ('</div></div>');
	}
}


var componentDB = new Array();
var componentNSMap = new Array();

componentDB ["http://www.csapi.org/schema/parlayx/common/v2_1"] =  new C (new Array(),
					new Array(),
					new Array(new CN("2/simpletype/TimeMetrics.html","TimeMetrics",false,null)),
					new Array(new CN("2/complextype/ChargingInformation.html","ChargingInformation",false,new Array(new CN("2/element/1.html","description",false,null),new CN("2/element/2.html","currency",false,null),new CN("2/element/3.html","amount",false,null),new CN("2/element/4.html","code",false,null))),new CN("2/complextype/PolicyException.html","PolicyException",false,new Array(new CN("2/element/5.html","messageId",false,null),new CN("2/element/6.html","text",false,null),new CN("2/element/7.html","variables",false,null))),new CN("2/complextype/ServiceError.html","ServiceError",false,new Array(new CN("2/element/8.html","messageId",false,null),new CN("2/element/9.html","text",false,null),new CN("2/element/10.html","variables",false,null))),new CN("2/complextype/ServiceException.html","ServiceException",false,new Array(new CN("2/element/11.html","messageId",false,null),new CN("2/element/12.html","text",false,null),new CN("2/element/13.html","variables",false,null))),new CN("2/complextype/SimpleReference.html","SimpleReference",false,new Array(new CN("2/element/14.html","endpoint",false,null),new CN("2/element/15.html","interfaceName",false,null),new CN("2/element/16.html","correlator",false,null))),new CN("2/complextype/TimeMetric.html","TimeMetric",false,new Array(new CN("2/element/0.html","metric",false,null),new CN("2/element/17.html","units",false,null)))),
					new Array(),
					new Array(new CN("2/element/PolicyException.html","PolicyException",false,null),new CN("2/element/ServiceException.html","ServiceException",false,null)),
					new Array());

componentNSMap ["http://www.csapi.org/schema/parlayx/common/v2_1"] = "2/index.html";
componentDB ["http://www.ibm.com/schema/twss/nm/v1_0"] =  new C (new Array(),
					new Array(),
					new Array(),
					new Array(new CN("1/complextype/integerRange.html","integerRange",false,null),new CN("1/complextype/notification.html","notification",false,null),new CN("1/complextype/NotificationDuplicateFault.html","NotificationDuplicateFault",false,null),new CN("1/complextype/NotificationNotFoundFault.html","NotificationNotFoundFault",false,null),new CN("1/complextype/NotificationRequestInvalidFault.html","NotificationRequestInvalidFault",false,null),new CN("1/complextype/NotificationServiceFault.html","NotificationServiceFault",false,null),new CN("1/complextype/NotificationServiceFaultWithoutRootCause.html","NotificationServiceFaultWithoutRootCause",false,null),new CN("1/complextype/NotificationServiceFaultWithPolicyExceptionRootCause.html","NotificationServiceFaultWithPolicyExceptionRootCause",false,null),new CN("1/complextype/NotificationServiceFaultWithServiceExceptionRootCause.html","NotificationServiceFaultWithServiceExceptionRootCause",false,null),new CN("1/complextype/NotificationTerminationNotSupportedFault.html","NotificationTerminationNotSupportedFault",false,null),new CN("1/complextype/statistics.html","statistics",false,null)),
					new Array(),
					new Array(new CN("1/element/adminSupportEndPoint.html","adminSupportEndPoint",false,null),new CN("1/element/adminTransactionID.html","adminTransactionID",false,null),new CN("1/element/correlator.html","correlator",false,null),new CN("1/element/deliveryFailureCount.html","deliveryFailureCount",false,null),new CN("1/element/deliverySuccessCount.html","deliverySuccessCount",false,null),new CN("1/element/endTimeInMillis.html","endTimeInMillis",false,null),new CN("1/element/globalTransactionID.html","globalTransactionID",false,null),new CN("1/element/inclusiveLowerBound.html","inclusiveLowerBound",false,null),new CN("1/element/inclusiveUpperBound.html","inclusiveUpperBound",false,null),new CN("1/element/invalidPart.html","invalidPart",false,null),new CN("1/element/invalidValue.html","invalidValue",false,null),new CN("1/element/lastDeliveryFailureInMillis.html","lastDeliveryFailureInMillis",false,null),new CN("1/element/lastDeliverySuccessInMillis.html","lastDeliverySuccessInMillis",false,null),new CN("1/element/lastStatisticsResetInMillis.html","lastStatisticsResetInMillis",false,null),new CN("1/element/maxCountPerTarget.html","maxCountPerTarget",false,null),new CN("1/element/messageId.html","messageId",false,null),new CN("1/element/minPeriodInMillis.html","minPeriodInMillis",false,null),new CN("1/element/notification.html","notification",false,null),new CN("1/element/notificationCriterion.html","notificationCriterion",false,null),new CN("1/element/NotificationDuplicateFault.html","NotificationDuplicateFault",false,null),new CN("1/element/notificationEndPoint.html","notificationEndPoint",false,null),new CN("1/element/NotificationNotFoundFault.html","NotificationNotFoundFault",false,null),new CN("1/element/notificationPortTypeName.html","notificationPortTypeName",false,null),new CN("1/element/notificationPortTypeNamespace.html","notificationPortTypeNamespace",false,null),new CN("1/element/NotificationRequestInvalidFault.html","NotificationRequestInvalidFault",false,null),new CN("1/element/NotificationServiceFault.html","NotificationServiceFault",false,null),new CN("1/element/NotificationTerminationNotSupportedFault.html","NotificationTerminationNotSupportedFault",false,null),new CN("1/element/operation.html","operation",false,null),new CN("1/element/operationTarget.html","operationTarget",false,null),new CN("1/element/requester.html","requester",false,null),new CN("1/element/service.html","service",false,null),new CN("1/element/startTimeInMillis.html","startTimeInMillis",false,null),new CN("1/element/statistics.html","statistics",false,null),new CN("1/element/text.html","text",false,null),new CN("1/element/variables.html","variables",false,null)),
					new Array());

componentNSMap ["http://www.ibm.com/schema/twss/nm/v1_0"] = "1/index.html";
componentDB ["http://www.ibm.com/wsdl/twss/nm/stat/publish/v1_0/interface"] =  new C (new Array(),
					new Array(),
					new Array(),
					new Array(new CN("3/complextype/deliveryFailedRequest.html","deliveryFailedRequest",false,null),new CN("3/complextype/deliveryFailedResponse.html","deliveryFailedResponse",false,null),new CN("3/complextype/deliverySucceededRequest.html","deliverySucceededRequest",false,null),new CN("3/complextype/deliverySucceededResponse.html","deliverySucceededResponse",false,null)),
					new Array(),
					new Array(new CN("3/element/deliveryFailedRequest.html","deliveryFailedRequest",false,null),new CN("3/element/deliveryFailedResponse.html","deliveryFailedResponse",false,null),new CN("3/element/deliverySucceededRequest.html","deliverySucceededRequest",false,null),new CN("3/element/deliverySucceededResponse.html","deliverySucceededResponse",false,null)),
					new Array());

componentNSMap ["http://www.ibm.com/wsdl/twss/nm/stat/publish/v1_0/interface"] = "3/index.html";
								   


