﻿/**
 *
 * Copyright (c) 2002-2004 Bluetetra Software.  All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL BLUETETRA SOFTWARE BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *  
 * http://www.bluetetra.com
 *
 */

var target = "content";
var xsd_ciFileName = "componentIndex.html";
var xsd_nsFilterFileName = "nsFilter.html";

function CN (href, name, appendNSFlag, children) {
	this.href = href;
	this.name = name;
	this.appendNSFlag = appendNSFlag;

	this.children = children;
	this.hasChild = (children != null) && (children.length>0);	
	
	this.namespace = null;
}

function C (attributeList, attributeGroupList,
						simpleTypeList, complexTypeList,
						modelGroupList, elementList, 
						notationList) 
{
	this.attributes = attributeList;
	this.attributegroups = attributeGroupList;
	this.simpletypes = simpleTypeList;
	this.complextypes = complexTypeList;
	this.modelgroups = modelGroupList;
	this.elements = elementList;
	this.notations = notationList;
}

function component_showAllComponents() {
	parent._xsdNsFilter = null;
	parent.index.location.href= "xsd/" + xsd_ciFileName;
}

function component_filterComponents () {
	parent._href = "xsd/" + xsd_ciFileName;
	window.open(xsd_nsFilterFileName, "_blank", 
		"height=200,width=400,location=no,menubar=no,scrollbars=yes,status=yes,resizable=yes,toolbar=no");

}

function component_groupByNS (flag) {
	parent._groupByNSFlag = flag;
	parent.index.location.href=xsd_ciFileName;	
}

function component_setFilterToAll() {
	var nsList = new Array();
	var i = 0;

	for (var ns in componentDB) {
		if (parent._xsdNsFilter == null) {
			if (ns == "http://schemas.xmlsoap.org/soap/encoding/") {
				//NOOP
			} else {
				nsList[i] = ns;
				i++;
			}
		} else {
			nsList[i] = ns; 
			i++;		
		}
	}

	parent._xsdNsFilter = nsList;
}

function component_showComponentsNoNS (nsList, componentList) {

	var components = new Array ();
	var n = 0;

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			components[n] = list[j];
			components[n].namespace = namespace;
			n++;	
		}	
	}
	
	components = components.sort(function (n1,n2) {return n1.name.toLowerCase().localeCompare (n2.name.toLowerCase());});

	component_outputList (null, components);	
}


function component_showComponentsNS (nsList, componentList) {

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			list[j].namespace = namespace;
		}	

		component_outputList (namespace, list);	
	}
}


function component_showComponents (nsList, componentList) {
	if (parent._groupByNSFlag) {
		component_showComponentsNS (nsList, componentList)
	} else {
		component_showComponentsNoNS (nsList, componentList)
	}
}

function component_showAttributes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var attributes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		attributes [i] = componentDB [nsList[i]].attributes;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, attributes);
}

function component_showAttributeGroups() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var attributegroups = new Array();
	var nss = new Array();		

	for (var i=0; i<nsList.length; i++) {
		attributegroups [i] = componentDB [nsList[i]].attributegroups;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, attributegroups);
}

function component_showSimpleTypes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var simpletypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		simpletypes [i] = componentDB [nsList[i]].simpletypes;	
		nss [i] = nsList[i];
	}		

	component_showComponents (nss, simpletypes);
}

function component_showComplexTypes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var complextypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		complextypes [i] = componentDB [nsList[i]].complextypes;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, complextypes);
}

function component_showElements() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var elements = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		elements [i] = componentDB [nsList[i]].elements;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, elements);
}

function component_showModelGroups() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var modelgroups = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		modelgroups [i] = componentDB [nsList[i]].modelgroups;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, modelgroups);
}

function component_showNotations() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var notations = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		notations [i] = componentDB [nsList[i]].notations;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, notations);

}


function component_getNodeText(node) {
	if (node.appendNSFlag) {
		return node.name + "("+encodeURI(node.namespace)+")";
	} else {
		return node.name;
	} 
}

function component_outputLeaf (node) {
	var str = '<span class="leaf">'+
			  '<nobr><img src="img/leaf.gif" hspace="2" align="middle">'+
			  '<a class="chref" href="'+node.href+
			  '" title="'+component_getNodeText(node)+
			  '" target="'+target+'">'+component_getNodeText(node)+'</a></nobr>'+
			  '</span><br />'
	
	document.write (str);
}

function component_outputNonLeaf (node) {
	//initially, the childnodes are hidden

	var str = '<div><div class="nonleaf">'+
			'<nobr><img style="cursor: pointer" src="img/plus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
			'<a class="chref" href="'+node.href+
			'" title="'+component_getNodeText(node)+
			'" target="'+target+'">'+component_getNodeText(node)+'</a></nobr></div>'+
			'<div style="display:none;margin-left: 0.8em">';

	document.write (str);

	var childs = node.children;
	for (var i=0; i<childs.length; i++) {
		component_outputTree (childs[i]);
	}					

	document.write ('</div></div>');
}

function component_outputTree (node) {
	if (node.hasChild == false) {
		component_outputLeaf (node);
	} else {
		component_outputNonLeaf (node);
	}
}

function component_outputList (ns, list) {	
	
	if (list == null || list.length<=0) {
		return;
	}

	if (parent._groupByNSFlag) {
		var fpath = componentNSMap[ns];

		var str = '<div class="nsBox"><div class="itemNS">'+
				'<nobr><img style="cursor: pointer" src="img/minus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
				'<a class="chref" href="'+fpath+
				'" title="'+encodeURI(ns)+
				'" target="'+target+'">'+encodeURI(ns)+'</a></nobr></div>'+
				'<div style="margin-left: 0.5em">';

		document.write (str);
	}

	for (var i=0; i<list.length; i++) {
		component_outputTree (list[i]);
	}
	
	if (parent._groupByNSFlag) {
		document.write ('</div></div>');
	}
}


var componentDB = new Array();
var componentNSMap = new Array();

componentDB ["http://www.csapi.org/schema/parlayx/common/v2_1"] =  new C (new Array(),
					new Array(),
					new Array(new CN("4/simpletype/TimeMetrics.html","TimeMetrics",false,null)),
					new Array(new CN("4/complextype/ChargingInformation.html","ChargingInformation",false,new Array(new CN("4/element/23.html","description",false,null),new CN("4/element/24.html","currency",false,null),new CN("4/element/25.html","amount",false,null),new CN("4/element/26.html","code",false,null))),new CN("4/complextype/PolicyException.html","PolicyException",false,new Array(new CN("4/element/27.html","messageId",false,null),new CN("4/element/28.html","text",false,null),new CN("4/element/29.html","variables",false,null))),new CN("4/complextype/ServiceError.html","ServiceError",false,new Array(new CN("4/element/30.html","messageId",false,null),new CN("4/element/31.html","text",false,null),new CN("4/element/32.html","variables",false,null))),new CN("4/complextype/ServiceException.html","ServiceException",false,new Array(new CN("4/element/33.html","messageId",false,null),new CN("4/element/34.html","text",false,null),new CN("4/element/35.html","variables",false,null))),new CN("4/complextype/SimpleReference.html","SimpleReference",false,new Array(new CN("4/element/36.html","endpoint",false,null),new CN("4/element/37.html","interfaceName",false,null),new CN("4/element/38.html","correlator",false,null))),new CN("4/complextype/TimeMetric.html","TimeMetric",false,new Array(new CN("4/element/22.html","metric",false,null),new CN("4/element/39.html","units",false,null)))),
					new Array(),
					new Array(new CN("4/element/PolicyException.html","PolicyException",false,null),new CN("4/element/ServiceException.html","ServiceException",false,null)),
					new Array());

componentNSMap ["http://www.csapi.org/schema/parlayx/common/v2_1"] = "4/index.html";
componentDB ["http://www.csapi.org/schema/parlayx/sms/v2_2"] =  new C (new Array(),
					new Array(),
					new Array(new CN("2/simpletype/DeliveryStatus.html","DeliveryStatus",true,null),new CN("2/simpletype/SmsFormat.html","SmsFormat",false,null)),
					new Array(new CN("2/complextype/DeliveryInformation.html","DeliveryInformation",false,new Array(new CN("2/element/3.html","address",false,null),new CN("2/element/4.html","deliveryStatus",false,null))),new CN("2/complextype/SmsMessage.html","SmsMessage",false,new Array(new CN("2/element/15.html","message",false,null),new CN("2/element/16.html","senderAddress",false,null),new CN("2/element/17.html","smsServiceActivationNumber",false,null),new CN("2/element/18.html","dateTime",false,null)))),
					new Array(),
					new Array(),
					new Array());

componentNSMap ["http://www.csapi.org/schema/parlayx/sms/v2_2"] = "2/index.html";
componentDB ["http://www.ibm.com/schema/soa/pxnotify/v1_0"] =  new C (new Array(),
					new Array(),
					new Array(new CN("3/simpletype/DeliveryMethod.html","DeliveryMethod",false,null),new CN("3/simpletype/DeliveryStatus.html","DeliveryStatus",true,null),new CN("3/simpletype/FailureType.html","FailureType",false,null)),
					new Array(new CN("3/complextype/InvocationException.html","InvocationException",false,new Array(new CN("3/element/19.html","messageID",false,null),new CN("3/element/20.html","text",false,null),new CN("3/element/21.html","variables",false,null))),new CN("3/complextype/SPNotificationExtension.html","SPNotificationExtension",false,new Array(new CN("3/element/5.html","globalTransactionID",false,null),new CN("3/element/6.html","appCorrelationID",false,null),new CN("3/element/7.html","service",false,null),new CN("3/element/8.html","notificationDestination",false,null),new CN("3/element/9.html","requesterID",false,null),new CN("3/element/10.html","deliveryMethod",false,null),new CN("3/element/11.html","confirmationEndPoint",false,null)))),
					new Array(),
					new Array(new CN("3/element/InvocationException.html","InvocationException",false,null),new CN("3/element/SPNotificationExtension.html","SPNotificationExtension",false,null)),
					new Array());

componentNSMap ["http://www.ibm.com/schema/soa/pxnotify/v1_0"] = "3/index.html";
componentDB ["http://www.ibm.com/schema/soa/pxsms/v1_0/local"] =  new C (new Array(),
					new Array(),
					new Array(),
					new Array(new CN("1/complextype/notifySmsDeliveryReceipt.html","notifySmsDeliveryReceipt",false,new Array(new CN("1/element/0.html","correlator",false,null),new CN("1/element/1.html","deliveryStatus",false,null),new CN("1/element/2.html","notificationExtension",false,null))),new CN("1/complextype/notifySmsDeliveryReceiptResponse.html","notifySmsDeliveryReceiptResponse",false,null),new CN("1/complextype/notifySmsReception.html","notifySmsReception",false,new Array(new CN("1/element/12.html","correlator",false,null),new CN("1/element/13.html","message",false,null),new CN("1/element/14.html","notificationExtension",false,null))),new CN("1/complextype/notifySmsReceptionResponse.html","notifySmsReceptionResponse",false,null)),
					new Array(),
					new Array(new CN("1/element/notifySmsDeliveryReceipt.html","notifySmsDeliveryReceipt",false,null),new CN("1/element/notifySmsDeliveryReceiptResponse.html","notifySmsDeliveryReceiptResponse",false,null),new CN("1/element/notifySmsReception.html","notifySmsReception",false,null),new CN("1/element/notifySmsReceptionResponse.html","notifySmsReceptionResponse",false,null)),
					new Array());

componentNSMap ["http://www.ibm.com/schema/soa/pxsms/v1_0/local"] = "1/index.html";
								   


