﻿/**
 *
 * Copyright (c) 2002-2004 Bluetetra Software.  All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL BLUETETRA SOFTWARE BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *  
 * http://www.bluetetra.com
 *
 */

var wc_target = "content";
var wc_fileName = "wsdlComponentIndex.html";
var wc_nsFilterFileName = "nsFilter.html";


function WCN (href, name, appendNSFlag, children) {
	this.href = href;
	this.name = name;
	this.appendNSFlag = appendNSFlag;

	this.children = children;
	this.hasChild = (children != null) && (children.length>0);	
	
	this.namespace = null;
}

function WC (serviceList, messageList, portTypeList, bindingList)
{
	this.services = serviceList;
	this.messages = messageList;
	this.portTypes = portTypeList;
	this.bindings = bindingList;
}

function wc_showAllComponents() {
	parent._wsdlNsFilter = null;
	parent.index.location.href= "wsdl/" + wc_fileName;
}

function wc_filterComponents () {
	parent._href = "wsdl/" + wc_fileName;
	window.open(wc_nsFilterFileName, "_blank", 
		"height=200,width=400,location=no,menubar=no,scrollbars=yes,status=yes,resizable=yes,toolbar=no");

}

function wc_groupByNS (flag) {
	parent._groupByNSFlag = flag;
	parent.index.location.href= wc_fileName;	
}

function wc_setFilterToAll() {
	var nsList = new Array();
	var i = 0;

	for (var ns in wcDB) {
		nsList[i] = ns; 		
		i++;
	}

	parent._wsdlNsFilter = nsList;
}


function wc_showComponentsNoNS (nsList, componentList) {

	var components = new Array ();
	var n = 0;

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			components[n] = list[j];
			components[n].namespace = namespace;
			n++;	
		}	
	}
	
	components = components.sort(function (n1,n2) {return n1.name.toLowerCase().localeCompare (n2.name.toLowerCase());});

	wc_outputList (null, components);	
}


function wc_showComponentsNS (nsList, componentList) {

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			list[j].namespace = namespace;
		}	

		wc_outputList (namespace, list);	
	}
}


function wc_showComponents (nsList, componentList) {
	if (parent._groupByNSFlag) {
		wc_showComponentsNS (nsList, componentList)
	} else {
		wc_showComponentsNoNS (nsList, componentList)
	}
}

function wc_showServices() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var services = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		services [i] = wcDB [nsList[i]].services;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, services);
}

function wc_showMessages() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var messages = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		messages [i] = wcDB [nsList[i]].messages;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, messages);
}

function wc_showPortTypes() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var portTypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		portTypes [i] = wcDB [nsList[i]].portTypes;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, portTypes);
}


function wc_showBindings() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var bindings = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		bindings [i] = wcDB [nsList[i]].bindings;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, bindings);
}

function wc_getNodeText(node) {
	if (node.appendNSFlag) {
		return node.name + "("+encodeURI(node.namespace)+")";
	} else {
		return node.name;
	} 
}

function wc_outputLeaf (node) {
	var str = '<span class="leaf">'+
			  '<nobr><img src="img/leaf.gif" hspace="2" align="middle">'+
			  '<a class="chref" href="'+node.href+
			  '" title="'+ wc_getNodeText(node)+
			  '" target="'+ wc_target+'">'+ wc_getNodeText(node)+'</a></nobr>'+
			  '</span><br />'
	
	document.write (str);
}

function wc_outputNonLeaf (node) {
	//initially, the childnodes are hidden

	var str = '<div><div class="nonleaf">'+
			'<nobr><img style="cursor: pointer" src="img/plus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
			'<a class="chref" href="'+node.href+
			'" title="'+ wc_getNodeText(node)+
			'" target="'+ wc_target +'">'+ wc_getNodeText(node)+'</a></nobr></div>'+
			'<div style="display:none;margin-left: 0.8em">';

	document.write (str);

	var childs = node.children;
	for (var i=0; i<childs.length; i++) {
		wc_outputTree (childs[i]);
	}					

	document.write ('</div></div>');
}

function wc_outputTree (node) {
	if (node.hasChild == false) {
		wc_outputLeaf (node);
	} else {
		wc_outputNonLeaf (node);
	}
}

function wc_outputList (ns, list) {	
	
	if (list == null || list.length<=0) {
		return;
	}

	if (parent._groupByNSFlag) {
		var fpath = wcNSMap[ns];

		var str = '<div class="nsBox"><div class="itemNS">'+
				'<nobr><img style="cursor: pointer" src="img/minus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
				'<a class="chref" href="'+fpath+
				'" title="'+encodeURI(ns)+
				'" target="'+ wc_target +'">'+encodeURI(ns)+'</a></nobr></div>'+
				'<div style="margin-left: 0.5em">';

		document.write (str);
	}

	for (var i=0; i<list.length; i++) {
		wc_outputTree (list[i]);
	}
	
	if (parent._groupByNSFlag) {
		document.write ('</div></div>');
	}
}

var wcDB = new Array();
var wcNSMap = new Array();

wcDB ["http://www.ibm.com/schema/twss/spm/admin/service/v2_0/interface"] =  new WC (
					new Array(),
					new Array(new WCN("4/message/ServiceAdministrationInterface_createOperationRequest.html","ServiceAdministrationInterface_createOperationRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_createOperationResponse.html","ServiceAdministrationInterface_createOperationResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_createServiceImplementationRequest.html","ServiceAdministrationInterface_createServiceImplementationRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_createServiceImplementationResponse.html","ServiceAdministrationInterface_createServiceImplementationResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_createServiceRequest.html","ServiceAdministrationInterface_createServiceRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_createServiceResponse.html","ServiceAdministrationInterface_createServiceResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_findMatchingServicesRequest.html","ServiceAdministrationInterface_findMatchingServicesRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_findMatchingServicesResponse.html","ServiceAdministrationInterface_findMatchingServicesResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_getAllOperationsRequest.html","ServiceAdministrationInterface_getAllOperationsRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_getAllOperationsResponse.html","ServiceAdministrationInterface_getAllOperationsResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_getChildrenRequest.html","ServiceAdministrationInterface_getChildrenRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_getChildrenResponse.html","ServiceAdministrationInterface_getChildrenResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_getOperationRequest.html","ServiceAdministrationInterface_getOperationRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_getOperationResponse.html","ServiceAdministrationInterface_getOperationResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_getParentChainRequest.html","ServiceAdministrationInterface_getParentChainRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_getParentChainResponse.html","ServiceAdministrationInterface_getParentChainResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_getServiceImplementationsRequest.html","ServiceAdministrationInterface_getServiceImplementationsRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_getServiceImplementationsResponse.html","ServiceAdministrationInterface_getServiceImplementationsResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_getServiceRequest.html","ServiceAdministrationInterface_getServiceRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_getServiceResponse.html","ServiceAdministrationInterface_getServiceResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_removeOperationRequest.html","ServiceAdministrationInterface_removeOperationRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_removeOperationResponse.html","ServiceAdministrationInterface_removeOperationResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_removeServiceImplementationRequest.html","ServiceAdministrationInterface_removeServiceImplementationRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_removeServiceImplementationResponse.html","ServiceAdministrationInterface_removeServiceImplementationResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_removeServiceRequest.html","ServiceAdministrationInterface_removeServiceRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_removeServiceResponse.html","ServiceAdministrationInterface_removeServiceResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_resolveOperationEnabledRequest.html","ServiceAdministrationInterface_resolveOperationEnabledRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_resolveOperationEnabledResponse.html","ServiceAdministrationInterface_resolveOperationEnabledResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_resolveServiceEnabledRequest.html","ServiceAdministrationInterface_resolveServiceEnabledRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_resolveServiceEnabledResponse.html","ServiceAdministrationInterface_resolveServiceEnabledResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_updateOperationRequest.html","ServiceAdministrationInterface_updateOperationRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_updateOperationResponse.html","ServiceAdministrationInterface_updateOperationResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_updateServiceImplementationRequest.html","ServiceAdministrationInterface_updateServiceImplementationRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_updateServiceImplementationResponse.html","ServiceAdministrationInterface_updateServiceImplementationResponse",false,null),new WCN("4/message/ServiceAdministrationInterface_updateServiceRequest.html","ServiceAdministrationInterface_updateServiceRequest",false,null),new WCN("4/message/ServiceAdministrationInterface_updateServiceResponse.html","ServiceAdministrationInterface_updateServiceResponse",false,null),new WCN("4/message/ServicePolicyException.html","ServicePolicyException",false,null)),
					new Array(new WCN("4/porttype/ServiceAdministrationInterface.html","ServiceAdministrationInterface",false,new Array(new WCN("4/operation/createOperation_4.html","createOperation",false,null),new WCN("4/operation/createService_0.html","createService",false,null),new WCN("4/operation/createServiceImplementation_8.html","createServiceImplementation",false,null),new WCN("4/operation/findMatchingServices_14.html","findMatchingServices",false,null),new WCN("4/operation/getAllOperations_15.html","getAllOperations",false,null),new WCN("4/operation/getChildren_16.html","getChildren",false,null),new WCN("4/operation/getOperation_6.html","getOperation",false,null),new WCN("4/operation/getParentChain_17.html","getParentChain",false,null),new WCN("4/operation/getService_2.html","getService",false,null),new WCN("4/operation/getServiceImplementations_10.html","getServiceImplementations",false,null),new WCN("4/operation/removeOperation_7.html","removeOperation",false,null),new WCN("4/operation/removeService_3.html","removeService",false,null),new WCN("4/operation/removeServiceImplementation_11.html","removeServiceImplementation",false,null),new WCN("4/operation/resolveOperationEnabled_13.html","resolveOperationEnabled",false,null),new WCN("4/operation/resolveServiceEnabled_12.html","resolveServiceEnabled",false,null),new WCN("4/operation/updateOperation_5.html","updateOperation",false,null),new WCN("4/operation/updateService_1.html","updateService",false,null),new WCN("4/operation/updateServiceImplementation_9.html","updateServiceImplementation",false,null)))),
					new Array()
					);

wcNSMap ["http://www.ibm.com/schema/twss/spm/admin/service/v2_0/interface"] = "4/index.html";
wcDB ["http://www.ibm.com/schema/twss/spm/admin/service/v2_0/service"] =  new WC (
					new Array(new WCN("3/service/ServiceAdministrationService.html","ServiceAdministrationService",false,null)),
					new Array(),
					new Array(),
					new Array(new WCN("3/binding/ServiceAdministrationInterfaceBinding.html","ServiceAdministrationInterfaceBinding",false,new Array(new WCN("4/operation/createOperation_4.html","createOperation",false,null),new WCN("4/operation/createService_0.html","createService",false,null),new WCN("4/operation/createServiceImplementation_8.html","createServiceImplementation",false,null),new WCN("4/operation/findMatchingServices_14.html","findMatchingServices",false,null),new WCN("4/operation/getAllOperations_15.html","getAllOperations",false,null),new WCN("4/operation/getChildren_16.html","getChildren",false,null),new WCN("4/operation/getOperation_6.html","getOperation",false,null),new WCN("4/operation/getParentChain_17.html","getParentChain",false,null),new WCN("4/operation/getService_2.html","getService",false,null),new WCN("4/operation/getServiceImplementations_10.html","getServiceImplementations",false,null),new WCN("4/operation/removeOperation_7.html","removeOperation",false,null),new WCN("4/operation/removeService_3.html","removeService",false,null),new WCN("4/operation/removeServiceImplementation_11.html","removeServiceImplementation",false,null),new WCN("4/operation/resolveOperationEnabled_13.html","resolveOperationEnabled",false,null),new WCN("4/operation/resolveServiceEnabled_12.html","resolveServiceEnabled",false,null),new WCN("4/operation/updateOperation_5.html","updateOperation",false,null),new WCN("4/operation/updateService_1.html","updateService",false,null),new WCN("4/operation/updateServiceImplementation_9.html","updateServiceImplementation",false,null))))
					);

wcNSMap ["http://www.ibm.com/schema/twss/spm/admin/service/v2_0/service"] = "3/index.html";
