﻿/**
 *
 * Copyright (c) 2002-2004 Bluetetra Software.  All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL BLUETETRA SOFTWARE BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *  
 * http://www.bluetetra.com
 *
 */

var target = "content";
var xsd_ciFileName = "componentIndex.html";
var xsd_nsFilterFileName = "nsFilter.html";

function CN (href, name, appendNSFlag, children) {
	this.href = href;
	this.name = name;
	this.appendNSFlag = appendNSFlag;

	this.children = children;
	this.hasChild = (children != null) && (children.length>0);	
	
	this.namespace = null;
}

function C (attributeList, attributeGroupList,
						simpleTypeList, complexTypeList,
						modelGroupList, elementList, 
						notationList) 
{
	this.attributes = attributeList;
	this.attributegroups = attributeGroupList;
	this.simpletypes = simpleTypeList;
	this.complextypes = complexTypeList;
	this.modelgroups = modelGroupList;
	this.elements = elementList;
	this.notations = notationList;
}

function component_showAllComponents() {
	parent._xsdNsFilter = null;
	parent.index.location.href= "xsd/" + xsd_ciFileName;
}

function component_filterComponents () {
	parent._href = "xsd/" + xsd_ciFileName;
	window.open(xsd_nsFilterFileName, "_blank", 
		"height=200,width=400,location=no,menubar=no,scrollbars=yes,status=yes,resizable=yes,toolbar=no");

}

function component_groupByNS (flag) {
	parent._groupByNSFlag = flag;
	parent.index.location.href=xsd_ciFileName;	
}

function component_setFilterToAll() {
	var nsList = new Array();
	var i = 0;

	for (var ns in componentDB) {
		if (parent._xsdNsFilter == null) {
			if (ns == "http://schemas.xmlsoap.org/soap/encoding/") {
				//NOOP
			} else {
				nsList[i] = ns;
				i++;
			}
		} else {
			nsList[i] = ns; 
			i++;		
		}
	}

	parent._xsdNsFilter = nsList;
}

function component_showComponentsNoNS (nsList, componentList) {

	var components = new Array ();
	var n = 0;

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			components[n] = list[j];
			components[n].namespace = namespace;
			n++;	
		}	
	}
	
	components = components.sort(function (n1,n2) {return n1.name.toLowerCase().localeCompare (n2.name.toLowerCase());});

	component_outputList (null, components);	
}


function component_showComponentsNS (nsList, componentList) {

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			list[j].namespace = namespace;
		}	

		component_outputList (namespace, list);	
	}
}


function component_showComponents (nsList, componentList) {
	if (parent._groupByNSFlag) {
		component_showComponentsNS (nsList, componentList)
	} else {
		component_showComponentsNoNS (nsList, componentList)
	}
}

function component_showAttributes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var attributes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		attributes [i] = componentDB [nsList[i]].attributes;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, attributes);
}

function component_showAttributeGroups() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var attributegroups = new Array();
	var nss = new Array();		

	for (var i=0; i<nsList.length; i++) {
		attributegroups [i] = componentDB [nsList[i]].attributegroups;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, attributegroups);
}

function component_showSimpleTypes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var simpletypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		simpletypes [i] = componentDB [nsList[i]].simpletypes;	
		nss [i] = nsList[i];
	}		

	component_showComponents (nss, simpletypes);
}

function component_showComplexTypes() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var complextypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		complextypes [i] = componentDB [nsList[i]].complextypes;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, complextypes);
}

function component_showElements() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var elements = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		elements [i] = componentDB [nsList[i]].elements;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, elements);
}

function component_showModelGroups() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var modelgroups = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		modelgroups [i] = componentDB [nsList[i]].modelgroups;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, modelgroups);
}

function component_showNotations() {
	if (parent._xsdNsFilter == null) {
		component_setFilterToAll();		
	}
	
	var nsList = parent._xsdNsFilter;
	var notations = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		notations [i] = componentDB [nsList[i]].notations;	
		nss[i] = nsList[i];
	}		

	component_showComponents (nss, notations);

}


function component_getNodeText(node) {
	if (node.appendNSFlag) {
		return node.name + "("+encodeURI(node.namespace)+")";
	} else {
		return node.name;
	} 
}

function component_outputLeaf (node) {
	var str = '<span class="leaf">'+
			  '<nobr><img src="img/leaf.gif" hspace="2" align="middle">'+
			  '<a class="chref" href="'+node.href+
			  '" title="'+component_getNodeText(node)+
			  '" target="'+target+'">'+component_getNodeText(node)+'</a></nobr>'+
			  '</span><br />'
	
	document.write (str);
}

function component_outputNonLeaf (node) {
	//initially, the childnodes are hidden

	var str = '<div><div class="nonleaf">'+
			'<nobr><img style="cursor: pointer" src="img/plus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
			'<a class="chref" href="'+node.href+
			'" title="'+component_getNodeText(node)+
			'" target="'+target+'">'+component_getNodeText(node)+'</a></nobr></div>'+
			'<div style="display:none;margin-left: 0.8em">';

	document.write (str);

	var childs = node.children;
	for (var i=0; i<childs.length; i++) {
		component_outputTree (childs[i]);
	}					

	document.write ('</div></div>');
}

function component_outputTree (node) {
	if (node.hasChild == false) {
		component_outputLeaf (node);
	} else {
		component_outputNonLeaf (node);
	}
}

function component_outputList (ns, list) {	
	
	if (list == null || list.length<=0) {
		return;
	}

	if (parent._groupByNSFlag) {
		var fpath = componentNSMap[ns];

		var str = '<div class="nsBox"><div class="itemNS">'+
				'<nobr><img style="cursor: pointer" src="img/minus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
				'<a class="chref" href="'+fpath+
				'" title="'+encodeURI(ns)+
				'" target="'+target+'">'+encodeURI(ns)+'</a></nobr></div>'+
				'<div style="margin-left: 0.5em">';

		document.write (str);
	}

	for (var i=0; i<list.length; i++) {
		component_outputTree (list[i]);
	}
	
	if (parent._groupByNSFlag) {
		document.write ('</div></div>');
	}
}


var componentDB = new Array();
var componentNSMap = new Array();

componentDB ["http://www.ibm.com/schema/twss/spm/admin/common/v2_0"] =  new C (new Array(),
					new Array(),
					new Array(new CN("1/simpletype/Description.html","Description",false,null),new CN("1/simpletype/OperationIdentifier.html","OperationIdentifier",false,null),new CN("1/simpletype/PolicyName.html","PolicyName",false,null),new CN("1/simpletype/RequesterIdentifier.html","RequesterIdentifier",false,null),new CN("1/simpletype/RequesterType.html","RequesterType",false,null),new CN("1/simpletype/ServiceIdentifier.html","ServiceIdentifier",false,null),new CN("1/simpletype/ServiceType.html","ServiceType",false,null),new CN("1/simpletype/stringLike.html","stringLike",false,null),new CN("1/simpletype/TypeName.html","TypeName",false,null)),
					new Array(new CN("1/complextype/BooleanResultList.html","BooleanResultList",false,new Array(new CN("1/element/45.html","result",false,null))),new CN("1/complextype/FaultStatus.html","FaultStatus",false,new Array(new CN("1/element/46.html","fault",false,null))),new CN("1/complextype/FaultStatusList.html","FaultStatusList",false,new Array(new CN("1/element/47.html","faultStatus",false,null))),new CN("1/complextype/NameList.html","NameList",false,new Array(new CN("1/element/11.html","name",false,null))),new CN("1/complextype/OperationDefinition.html","OperationDefinition",false,new Array(new CN("1/element/26.html","service",false,null),new CN("1/element/6.html","operation",false,null),new CN("1/element/51.html","enabled",false,null),new CN("1/element/0.html","description",false,null))),new CN("1/complextype/OperationDefinitionList.html","OperationDefinitionList",false,new Array(new CN("1/element/54.html","definition",false,null))),new CN("1/complextype/PolicyType.html","PolicyType",false,new Array(new CN("1/element/43.html","typeName",false,null),new CN("1/element/57.html","editable",false,null),new CN("1/element/58.html","editMask",false,null),new CN("1/element/59.html","encrypted",false,null),new CN("1/element/1.html","description",false,null))),new CN("1/complextype/PolicyTypeList.html","PolicyTypeList",false,new Array(new CN("1/element/60.html","type",false,null))),new CN("1/complextype/PolicyValue.html","PolicyValue",false,new Array(new CN("1/element/44.html","type",false,null),new CN("1/element/61.html","value",false,null))),new CN("1/complextype/PolicyValueList.html","PolicyValueList",false,new Array(new CN("1/element/62.html","policyValue",false,null))),new CN("1/complextype/RequesterDefinition.html","RequesterDefinition",false,new Array(new CN("1/element/14.html","requester",false,null),new CN("1/element/13.html","parentGroup",false,null),new CN("1/element/64.html","enabled",false,null),new CN("1/element/2.html","description",false,null),new CN("1/element/18.html","definitionType",false,null))),new CN("1/complextype/RequesterDefinitionList.html","RequesterDefinitionList",false,new Array(new CN("1/element/65.html","definition",false,null))),new CN("1/complextype/RequesterList.html","RequesterList",false,new Array(new CN("1/element/15.html","requester",false,null))),new CN("1/complextype/ScopedPolicies.html","ScopedPolicies",false,new Array(new CN("1/element/66.html","scopedPolicy",false,null))),new CN("1/complextype/ScopedPolicy.html","ScopedPolicy",false,new Array(new CN("1/element/16.html","requesterIdentifier",false,null),new CN("1/element/33.html","serviceIdentifier",false,null),new CN("1/element/9.html","operation",false,null),new CN("1/element/12.html","name",false,null),new CN("1/element/63.html","value",false,null))),new CN("1/complextype/ServiceDefinition.html","ServiceDefinition",false,new Array(new CN("1/element/35.html","service",false,null),new CN("1/element/34.html","parentGroup",false,null),new CN("1/element/67.html","enabled",false,null),new CN("1/element/3.html","description",false,null),new CN("1/element/41.html","definitionType",false,null))),new CN("1/complextype/ServiceDefinitionList.html","ServiceDefinitionList",false,new Array(new CN("1/element/70.html","definition",false,null))),new CN("1/complextype/ServiceImplDefinition.html","ServiceImplDefinition",false,new Array(new CN("1/element/37.html","service",false,null),new CN("1/element/36.html","implName",false,null),new CN("1/element/75.html","enabled",false,null),new CN("1/element/4.html","description",false,null))),new CN("1/complextype/ServiceImplDefinitionList.html","ServiceImplDefinitionList",false,new Array(new CN("1/element/77.html","definition",false,null))),new CN("1/complextype/ServicePolicyException.html","ServicePolicyException",false,new Array(new CN("1/element/48.html","messageID",false,null),new CN("1/element/49.html","text",false,null),new CN("1/element/50.html","variables",false,null))),new CN("1/complextype/Subscription.html","Subscription",false,new Array(new CN("1/element/17.html","requester",false,null),new CN("1/element/39.html","service",false,null),new CN("1/element/10.html","operation",false,null),new CN("1/element/38.html","implementation",false,null))),new CN("1/complextype/SubscriptionList.html","SubscriptionList",false,new Array(new CN("1/element/80.html","subscription",false,null)))),
					new Array(),
					new Array(new CN("1/element/ServicePolicyException.html","ServicePolicyException",false,null)),
					new Array());

componentNSMap ["http://www.ibm.com/schema/twss/spm/admin/common/v2_0"] = "1/index.html";
componentDB ["http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local"] =  new C (new Array(),
					new Array(),
					new Array(),
					new Array(new CN("2/complextype/createOperationRequest.html","createOperationRequest",false,new Array(new CN("2/element/52.html","definition",false,null))),new CN("2/complextype/createOperationResponse.html","createOperationResponse",false,null),new CN("2/complextype/createServiceImplementationRequest.html","createServiceImplementationRequest",false,new Array(new CN("2/element/76.html","definition",false,null))),new CN("2/complextype/createServiceImplementationResponse.html","createServiceImplementationResponse",false,null),new CN("2/complextype/createServiceRequest.html","createServiceRequest",false,new Array(new CN("2/element/68.html","definition",false,null))),new CN("2/complextype/createServiceResponse.html","createServiceResponse",false,null),new CN("2/complextype/findMatchingServicesRequest.html","findMatchingServicesRequest",false,new Array(new CN("2/element/42.html","pattern",false,null),new CN("2/element/19.html","atOrBelowGroup",false,null),new CN("2/element/40.html","definitionType",false,null))),new CN("2/complextype/findMatchingServicesResponse.html","findMatchingServicesResponse",false,new Array(new CN("2/element/72.html","definitions",false,null))),new CN("2/complextype/getAllOperationsRequest.html","getAllOperationsRequest",false,new Array(new CN("2/element/20.html","service",false,null))),new CN("2/complextype/getAllOperationsResponse.html","getAllOperationsResponse",false,new Array(new CN("2/element/56.html","definitions",false,null))),new CN("2/complextype/getChildrenRequest.html","getChildrenRequest",false,new Array(new CN("2/element/21.html","service",false,null))),new CN("2/complextype/getChildrenResponse.html","getChildrenResponse",false,new Array(new CN("2/element/73.html","definitions",false,null))),new CN("2/complextype/getOperationRequest.html","getOperationRequest",false,new Array(new CN("2/element/22.html","service",false,null),new CN("2/element/5.html","operation",false,null))),new CN("2/complextype/getOperationResponse.html","getOperationResponse",false,new Array(new CN("2/element/53.html","definition",false,null))),new CN("2/complextype/getParentChainRequest.html","getParentChainRequest",false,new Array(new CN("2/element/23.html","service",false,null))),new CN("2/complextype/getParentChainResponse.html","getParentChainResponse",false,new Array(new CN("2/element/74.html","definitions",false,null))),new CN("2/complextype/getServiceImplementationsRequest.html","getServiceImplementationsRequest",false,new Array(new CN("2/element/24.html","service",false,null))),new CN("2/complextype/getServiceImplementationsResponse.html","getServiceImplementationsResponse",false,new Array(new CN("2/element/79.html","definitions",false,null))),new CN("2/complextype/getServiceRequest.html","getServiceRequest",false,new Array(new CN("2/element/25.html","service",false,null))),new CN("2/complextype/getServiceResponse.html","getServiceResponse",false,new Array(new CN("2/element/69.html","definition",false,null))),new CN("2/complextype/removeOperationRequest.html","removeOperationRequest",false,new Array(new CN("2/element/27.html","service",false,null),new CN("2/element/7.html","operation",false,null))),new CN("2/complextype/removeOperationResponse.html","removeOperationResponse",false,null),new CN("2/complextype/removeServiceImplementationRequest.html","removeServiceImplementationRequest",false,new Array(new CN("2/element/29.html","service",false,null),new CN("2/element/28.html","implName",false,null))),new CN("2/complextype/removeServiceImplementationResponse.html","removeServiceImplementationResponse",false,null),new CN("2/complextype/removeServiceRequest.html","removeServiceRequest",false,new Array(new CN("2/element/30.html","service",false,null),new CN("2/element/81.html","includingChildren",false,null))),new CN("2/complextype/removeServiceResponse.html","removeServiceResponse",false,null),new CN("2/complextype/resolveOperationEnabledRequest.html","resolveOperationEnabledRequest",false,new Array(new CN("2/element/31.html","service",false,null),new CN("2/element/8.html","operation",false,null))),new CN("2/complextype/resolveOperationEnabledResponse.html","resolveOperationEnabledResponse",false,new Array(new CN("2/element/82.html","enabled",false,null))),new CN("2/complextype/resolveServiceEnabledRequest.html","resolveServiceEnabledRequest",false,new Array(new CN("2/element/32.html","service",false,null))),new CN("2/complextype/resolveServiceEnabledResponse.html","resolveServiceEnabledResponse",false,new Array(new CN("2/element/83.html","enabled",false,null))),new CN("2/complextype/updateOperationRequest.html","updateOperationRequest",false,new Array(new CN("2/element/55.html","definition",false,null))),new CN("2/complextype/updateOperationResponse.html","updateOperationResponse",false,null),new CN("2/complextype/updateServiceImplementationRequest.html","updateServiceImplementationRequest",false,new Array(new CN("2/element/78.html","definition",false,null))),new CN("2/complextype/updateServiceImplementationResponse.html","updateServiceImplementationResponse",false,null),new CN("2/complextype/updateServiceRequest.html","updateServiceRequest",false,new Array(new CN("2/element/71.html","definition",false,null))),new CN("2/complextype/updateServiceResponse.html","updateServiceResponse",false,null)),
					new Array(),
					new Array(new CN("2/element/createOperationRequest.html","createOperationRequest",false,null),new CN("2/element/createOperationResponse.html","createOperationResponse",false,null),new CN("2/element/createServiceImplementationRequest.html","createServiceImplementationRequest",false,null),new CN("2/element/createServiceImplementationResponse.html","createServiceImplementationResponse",false,null),new CN("2/element/createServiceRequest.html","createServiceRequest",false,null),new CN("2/element/createServiceResponse.html","createServiceResponse",false,null),new CN("2/element/findMatchingServicesRequest.html","findMatchingServicesRequest",false,null),new CN("2/element/findMatchingServicesResponse.html","findMatchingServicesResponse",false,null),new CN("2/element/getAllOperationsRequest.html","getAllOperationsRequest",false,null),new CN("2/element/getAllOperationsResponse.html","getAllOperationsResponse",false,null),new CN("2/element/getChildrenRequest.html","getChildrenRequest",false,null),new CN("2/element/getChildrenResponse.html","getChildrenResponse",false,null),new CN("2/element/getOperationRequest.html","getOperationRequest",false,null),new CN("2/element/getOperationResponse.html","getOperationResponse",false,null),new CN("2/element/getParentChainRequest.html","getParentChainRequest",false,null),new CN("2/element/getParentChainResponse.html","getParentChainResponse",false,null),new CN("2/element/getServiceImplementationsRequest.html","getServiceImplementationsRequest",false,null),new CN("2/element/getServiceImplementationsResponse.html","getServiceImplementationsResponse",false,null),new CN("2/element/getServiceRequest.html","getServiceRequest",false,null),new CN("2/element/getServiceResponse.html","getServiceResponse",false,null),new CN("2/element/removeOperationRequest.html","removeOperationRequest",false,null),new CN("2/element/removeOperationResponse.html","removeOperationResponse",false,null),new CN("2/element/removeServiceImplementationRequest.html","removeServiceImplementationRequest",false,null),new CN("2/element/removeServiceImplementationResponse.html","removeServiceImplementationResponse",false,null),new CN("2/element/removeServiceRequest.html","removeServiceRequest",false,null),new CN("2/element/removeServiceResponse.html","removeServiceResponse",false,null),new CN("2/element/resolveOperationEnabledRequest.html","resolveOperationEnabledRequest",false,null),new CN("2/element/resolveOperationEnabledResponse.html","resolveOperationEnabledResponse",false,null),new CN("2/element/resolveServiceEnabledRequest.html","resolveServiceEnabledRequest",false,null),new CN("2/element/resolveServiceEnabledResponse.html","resolveServiceEnabledResponse",false,null),new CN("2/element/updateOperationRequest.html","updateOperationRequest",false,null),new CN("2/element/updateOperationResponse.html","updateOperationResponse",false,null),new CN("2/element/updateServiceImplementationRequest.html","updateServiceImplementationRequest",false,null),new CN("2/element/updateServiceImplementationResponse.html","updateServiceImplementationResponse",false,null),new CN("2/element/updateServiceRequest.html","updateServiceRequest",false,null),new CN("2/element/updateServiceResponse.html","updateServiceResponse",false,null)),
					new Array());

componentNSMap ["http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local"] = "2/index.html";
								   


