﻿/**
 *
 * Copyright (c) 2002-2004 Bluetetra Software.  All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL BLUETETRA SOFTWARE BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *  
 * http://www.bluetetra.com
 *
 */

var target = "content";
var xsd_tiFileName = "typeTreeIndex.html";
var xsd_nsFilterFileName = "nsFilter.html";

function TN (href, prefix, ns, name, relation, simpletypeflag, children) {
	this.href = href;
	this.prefix = prefix;
	this.namespace = ns;
	this.name = name;
	this.relation = relation;
	this.simpletypeflag = simpletypeflag;
	this.children = children;

	this.hasChild = (children != null) && (children.length>0);	
}

function T (typeTree)
{
	this.typeTree = typeTree;
}

function typetree_showAllTypes() {
	parent._xsdNsFilter = null;
	parent.index.location.href= "xsd/" + xsd_tiFileName;
}

function typetree_filterTypes () {
	parent._href = "xsd/" + xsd_tiFileName;
	window.open(xsd_nsFilterFileName, "_blank", 
		"height=200,width=400,location=no,menubar=no,scrollbars=yes,status=yes,resizable=yes,toolbar=no");
}

function typetree_showTypes() {
	if (parent._xsdNsFilter == null) {
		typetree_setFilterToAll();
	}

	var nsList = parent._xsdNsFilter;
	var typetrees = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		typetrees [i] = typetreeDB [nsList[i]];	
		nss[i] = nsList[i];
	}		
	
	typetree_showTree (nss, typetrees); 
}

function typetree_setFilterToAll() {
	var nsList = new Array();
	var i = 0;

	for (var ns in typetreeDB) {
		if (parent._xsdNsFilter == null) {
			if (ns == "http://schemas.xmlsoap.org/soap/encoding/") {
				//NOOP
			} else {
				nsList[i] = ns;
				i++;
			}
		} else {
			nsList[i] = ns; 
			i++;		
		}
	}


	parent._xsdNsFilter = nsList;
}


function typetree_showTree (nsList, typetrees) {
	for (var i=0; i<nsList.length; i++) {
		var fpath = typetreeNSMap[nsList[i]];
		
		var str = '<div class="nsBox"><div class="itemNS">'+
			'<nobr><img style="cursor: pointer" src="img/minus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
			'<a class="chref" href="'+fpath+
			'" title="'+encodeURI(nsList[i])+
			'" target="'+target+'">'+encodeURI(nsList[i])+'</a></nobr></div>'+
			'<div style="margin-left: 0.5em">';		

		document.write (str);

		typetree_outputList (typetrees[i].typeTree);
		

		document.write ('</div></div>');
	}
} 

function typetree_outputList (list) {
	for (var i=0; i<list.length; i++) {
		typetree_outputTree (list[i]);
	}
}

function typetree_outputTree (node) {
	if (node.hasChild == false) {
		typetree_outputLeaf (node);
	} else {
		typetree_outputNonLeaf (node);
	}
}


function typetree_outputLeaf (node) {
	var str = null;
	var nodeStr = null;

	if (node.prefix.length>0) {
		nodeStr = prefixedAnchorString(node)
	} else {
		nodeStr = anchorString (node)
	}

	str = '<span class="leaf"><nobr>' +
		  '<img src="img/leaf.gif" hspace="2" align="middle">' + 
		  nodeStr + '</nobr></span><br />';

	document.write (str);
}

function prefixedAnchorString (node) {
	return  '<a class="chref" href="'+node.href+
			'" target="'+target+ '"'+
			' title="ns=' + encodeURI(node.namespace)+'">'+
			node.prefix+':'+'</a>'+
			'<a class="chref" href="'+node.href+'" target="'+target+ '"'+
			' title="ns=' + encodeURI(node.namespace)+'">'+ node.name +
			'</a>'+typetree_getNodeIcon(node);
}

function anchorString (node) {
	return 	'<a class="chref" href="'+node.href+'" target="'+target+'"'+
			' title="ns=' + encodeURI(node.namespace)+'">'+ node.name +
			'</a>'+typetree_getNodeIcon(node);

}

function typetree_outputNonLeaf (node) {
	var str = null;
	var nodeStr = null;

	if (node.prefix.length>0) {
		nodeStr = prefixedAnchorString(node);
	} else {
		nodeStr = anchorString (node);
	}
		
	str = '<div><div class="nonleaf">'+
			'<nobr><img style="cursor: pointer" src="img/minus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
			nodeStr +
			'</nobr></div>'+
			'<div style="margin-left: 0.8em">';

	document.write (str);

	var childs = node.children;
	for (var i=0; i<childs.length; i++) {
		typetree_outputTree (childs[i]);
	}					

	document.write ('</div></div>');
}

function typetree_getNodeIcon(node) {
	var rStr = null;
	if (node.relation == "none") {
		rStr = "";
	} else if (node.relation == "extension") {
		rStr = '<img alt="derived by extension" border="0" hspace="2" align="middle" src="img/extension.gif">';
	
	} else if (node.relation == "restriction") {
		rStr = '<img alt="derived by restriction" border="0" hspace="2" align="middle" src="img/restriction.gif">';
	
	} else if (node.relation == "list") {
		rStr = '<img alt="derived by list" border="0" hspace="2" align="middle" src="img/list.gif">';
	
	} else if (node.relation == "union") {
		rStr = '<img alt="derived by union" border="0" hspace="2" align="middle" src="img/union.gif">';
	
	}
	
	var typeStr = null;
	
	if (node.simpletypeflag) {
		typeStr = '<img alt="simple type" border="0" hspace="2" align="middle" src="img/simple.gif">'; 
	} else {
		typeStr = '<img alt="complex type" border="0" hspace="2" align="middle" src="img/complex.gif">';	
	} 

	return typeStr + rStr;
}

var typetreeDB = new Array();
var typetreeNSMap = new Array();

typetreeDB ["http://www.ibm.com/schema/twss/spm/admin/common/v2_0"] =  new T (new Array (new TN("1/complextype/BooleanResultList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","BooleanResultList","none",false,null),new TN("1/complextype/FaultStatus.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","FaultStatus","none",false,null),new TN("1/complextype/FaultStatusList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","FaultStatusList","none",false,null),new TN("1/complextype/NameList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","NameList","none",false,null),new TN("1/complextype/OperationDefinition.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","OperationDefinition","none",false,null),new TN("1/complextype/OperationDefinitionList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","OperationDefinitionList","none",false,null),new TN("1/complextype/PolicyType.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","PolicyType","none",false,null),new TN("1/complextype/PolicyTypeList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","PolicyTypeList","none",false,null),new TN("1/complextype/PolicyValue.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","PolicyValue","none",false,null),new TN("1/complextype/PolicyValueList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","PolicyValueList","none",false,null),new TN("1/complextype/RequesterDefinition.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","RequesterDefinition","none",false,null),new TN("1/complextype/RequesterDefinitionList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","RequesterDefinitionList","none",false,null),new TN("1/complextype/RequesterList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","RequesterList","none",false,null),new TN("1/complextype/ScopedPolicies.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ScopedPolicies","none",false,null),new TN("1/complextype/ScopedPolicy.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ScopedPolicy","none",false,null),new TN("1/complextype/ServiceDefinition.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ServiceDefinition","none",false,null),new TN("1/complextype/ServiceDefinitionList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ServiceDefinitionList","none",false,null),new TN("1/complextype/ServiceImplDefinition.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ServiceImplDefinition","none",false,null),new TN("1/complextype/ServiceImplDefinitionList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ServiceImplDefinitionList","none",false,null),new TN("1/complextype/ServicePolicyException.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ServicePolicyException","none",false,null),new TN("http://www.w3.org/TR/xmlschema-2/#string","xsd","http://www.w3.org/2001/XMLSchema","string","none",true,new Array(new TN("1/simpletype/Description.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","Description","restriction",true,null),new TN("1/simpletype/OperationIdentifier.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","OperationIdentifier","restriction",true,null),new TN("1/simpletype/PolicyName.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","PolicyName","restriction",true,null),new TN("1/simpletype/RequesterIdentifier.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","RequesterIdentifier","restriction",true,null),new TN("1/simpletype/RequesterType.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","RequesterType","restriction",true,null),new TN("1/simpletype/ServiceIdentifier.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ServiceIdentifier","restriction",true,null),new TN("1/simpletype/ServiceType.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","ServiceType","restriction",true,null),new TN("1/simpletype/stringLike.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","stringLike","restriction",true,null),new TN("1/simpletype/TypeName.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","TypeName","restriction",true,null))),new TN("1/complextype/Subscription.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","Subscription","none",false,null),new TN("1/complextype/SubscriptionList.html","","http://www.ibm.com/schema/twss/spm/admin/common/v2_0","SubscriptionList","none",false,null)));
typetreeNSMap ["http://www.ibm.com/schema/twss/spm/admin/common/v2_0"] = "1/index.html";
typetreeDB ["http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local"] =  new T (new Array (new TN("2/complextype/createOperationRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","createOperationRequest","none",false,null),new TN("2/complextype/createOperationResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","createOperationResponse","none",false,null),new TN("2/complextype/createServiceImplementationRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","createServiceImplementationRequest","none",false,null),new TN("2/complextype/createServiceImplementationResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","createServiceImplementationResponse","none",false,null),new TN("2/complextype/createServiceRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","createServiceRequest","none",false,null),new TN("2/complextype/createServiceResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","createServiceResponse","none",false,null),new TN("2/complextype/findMatchingServicesRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","findMatchingServicesRequest","none",false,null),new TN("2/complextype/findMatchingServicesResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","findMatchingServicesResponse","none",false,null),new TN("2/complextype/getAllOperationsRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getAllOperationsRequest","none",false,null),new TN("2/complextype/getAllOperationsResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getAllOperationsResponse","none",false,null),new TN("2/complextype/getChildrenRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getChildrenRequest","none",false,null),new TN("2/complextype/getChildrenResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getChildrenResponse","none",false,null),new TN("2/complextype/getOperationRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getOperationRequest","none",false,null),new TN("2/complextype/getOperationResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getOperationResponse","none",false,null),new TN("2/complextype/getParentChainRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getParentChainRequest","none",false,null),new TN("2/complextype/getParentChainResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getParentChainResponse","none",false,null),new TN("2/complextype/getServiceImplementationsRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getServiceImplementationsRequest","none",false,null),new TN("2/complextype/getServiceImplementationsResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getServiceImplementationsResponse","none",false,null),new TN("2/complextype/getServiceRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getServiceRequest","none",false,null),new TN("2/complextype/getServiceResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","getServiceResponse","none",false,null),new TN("2/complextype/removeOperationRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","removeOperationRequest","none",false,null),new TN("2/complextype/removeOperationResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","removeOperationResponse","none",false,null),new TN("2/complextype/removeServiceImplementationRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","removeServiceImplementationRequest","none",false,null),new TN("2/complextype/removeServiceImplementationResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","removeServiceImplementationResponse","none",false,null),new TN("2/complextype/removeServiceRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","removeServiceRequest","none",false,null),new TN("2/complextype/removeServiceResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","removeServiceResponse","none",false,null),new TN("2/complextype/resolveOperationEnabledRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","resolveOperationEnabledRequest","none",false,null),new TN("2/complextype/resolveOperationEnabledResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","resolveOperationEnabledResponse","none",false,null),new TN("2/complextype/resolveServiceEnabledRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","resolveServiceEnabledRequest","none",false,null),new TN("2/complextype/resolveServiceEnabledResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","resolveServiceEnabledResponse","none",false,null),new TN("2/complextype/updateOperationRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","updateOperationRequest","none",false,null),new TN("2/complextype/updateOperationResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","updateOperationResponse","none",false,null),new TN("2/complextype/updateServiceImplementationRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","updateServiceImplementationRequest","none",false,null),new TN("2/complextype/updateServiceImplementationResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","updateServiceImplementationResponse","none",false,null),new TN("2/complextype/updateServiceRequest.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","updateServiceRequest","none",false,null),new TN("2/complextype/updateServiceResponse.html","","http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local","updateServiceResponse","none",false,null)));
typetreeNSMap ["http://www.ibm.com/schema/twss/spm/admin/service/v2_0/local"] = "2/index.html";
								   


